var factura = 
{
	templates: 
	{
		addresses:
		{
			main: '<div>\
				<div>Filter:</div>\
				<div>Jump: </div>\
				<div>\
					Sorting: <select class="options sorting" name="SORTING" title="${Labels.TOOLS.Sorting}">\
						<option value=""></option>\
						<option value="NUMMER">${Labels.ADDRESSES.sort_NUMMER}</option>\
						<option value="FIRMA">${Labels.ADDRESSES.sort_FIRMA}</option>\
						<option value="NAME">${Labels.ADDRESSES.sort_NAME}</option>\
					</select>\
				</div>\
				<div class="content"></div>\
				<div>Funktionen</div>\
			</div>'
			,overview: '<table class="overview">\
				<tr>\
					<th>&nbsp;</th><th>Nummer</th><th>Firma</th><th>Name</th><th>Vorname</th><th>Straße</th><th>PLZ</th><th>Ort</th>\
				</tr>\
				{{tmpl(ROWS) "factura.templates.addresses.overview_row"}}\
			</table>'
			,overview_row: '<tr>\
				<td></td><td>${NUMMER}</td><td>${FIRMA}</td><td>${NAME}</td><td>${VORNAME}</td><td>${STRASSE}</td><td>${PLZ}</td><td>${ORT}</td>'
		}
		,projects:
		{
			main: '<div>\
				<div>Filter</div>\
				<div>\
					<select class="options sorting" name="SORTING" title="${Labels.TOOLS.sorting}">\
						<option value=""></option>\
						<option value="LICENCE_PLATE">[var.Labels.VEHICLE.registration_plate]</option>\
						<option value="PRODUCER">[var.Labels.VEHICLE.producer]</option>\
						<option value="TYPE">[var.Labels.VEHICLE.type]</option>\
					</select>\
				</div>\
				<div>{{tmpl "factura.templates.projects.overview"}}</div>\
				<div>Funktionen</div>\
			</div>'
			,overview: '<table class="overview">\
				<tr>\
					<th>&nbsp;</th><th>Bezeichnung</th><th>Kunde</th><th>Rechnung</th><th>Projektende</th><th>Projektvolumen</th>\
				</tr>\
				<tbody></tbody>\
			</table>'
		}
	}
	,content:
	{
		show: function( item )
		{
			switch ( item )
			{
				case 'addresses':
					// show table
					$.tmpl( "factura.templates.addresses.main" ).appendTo( $('#addresses').html('') )
					// load content
					factura.content.addresses.load();
					break;
			}
		}
		,addresses:
		{
			load: function ( options ) 
			{
				// load content
				$.ajax(
				{
					url: 'ajax_overviews.json.php'
					,type: 'POST'
					,dataType: 'json'
					,data: $.extend({}, { SCOPE: 'addresses.overview' }, options )
					,success: function ( data )
					{
						if ( data.ERROR )
							application.Error( data.ERROR );
						else
						{
							$.tmpl( "factura.templates.addresses.overview", [{ ROWS: data['DATA'] }] ).appendTo( $('#addresses').find('.content').html('') );
							// set sorting + filtering
						}
						
					}
					,error: function ( jqXHR, textStatus, errorThrown )
					{
						application.Error(jqXHR.responseText);
					}
				});					
			}
		}
	}
	,tools:
	{
		sorting_change: function ()
		{
			eval( 'factura.content.' + $(this).closest('.SCOPE').attr('id') + '.load({SORTING: $(this).val()})' );
		}	
	}
}
