	/* preload images */
	//imagesLoader ( 'images/', [ 'star_0.png', 'star_0.25.png', 'star_0.5.png', 'star_0.75.png', 'star_1.png', 'green-grey.gif', 'green-check.gif', 'question_mark.gif', 'Header.jpg' ] );

	/* check firebug console for debugging */
	try	{ console.log ( 'init debug' );	}
	catch ( e )
	{
		console = { log: function ( txt ) { /*throw new Error ( txt )*/ $('#Console pre').text(  txt + " <=<=< " + $('#Console pre').text() ) } };
	}

	/**TODO**: develop global login check */

	application =
	{
		Error: function ( MESSAGE )
		{
			$('#ErrorDialog').html( MESSAGE ).dialog('open');
		}
		,Message: function ( MESSAGE )
		{
			$('#MessageDialog').html( MESSAGE ).dialog('open');
		}
		,Confirm: function ( MESSAGE, myFUNCTION )
		{
			application._confirmTodo = myFUNCTION;
			$('#ConfirmDialog').html( MESSAGE ).dialog('open');
		}
		,_confirmTodo: function () { }
		,renderTemplates: function ( object, name )
		{
			if ( typeof object == 'object' )
				for ( var index in object )
					application.renderTemplates( object[index], name + '.' + index )
			else if ( typeof object == 'string' )
			{
				$.template( name, object );
			}
		}
		,Login: function ( USER, PASSWORD, okFUNCTION )
		{
			application._confirmTodo = okFUNCTION;
			$('#LoginDialog').dialog('open');
		}
		,_doLogin: function ()
		{
			$.ajax({
				type: 'POST'
				,url: 'login.ajax.php'
				,data: $('#LoginDialog').find(':input').serialize()
				,success: function ( data )
				{
					_okLogin();
				}
			});
		}
		,_okLogin: function () { }
		,prepareSimpleForm: function ( parent )
		{
			$(parent).find('.simpleForm input').each( function () {
				$(this).addClass( $(this).attr('type') );
//				if ( $(this).attr('name') == '' )
					$(this).attr( 'name', $(this).attr('id').rightStringAt('__') );
			} );
			$(parent).find('.simpleForm textarea').each( function () {
//				if ( $(this).attr('name') == '' )
					$(this).attr( 'name', $(this).attr('id').rightStringAt('__') );
			} );
			$(parent).find('.simpleForm input').not('[readonly]').focus( function () { $(this).addClass( $(this).attr('type') + '_active' ) } );
			$(parent).find('.simpleForm input').not('[readonly]').blur( function () { $(this).removeClass( $(this).attr('type') + '_active' ) } );
			$(parent).find('.simpleForm input').not('[readonly]').change( function () { console.log($(this)); $(this).addClass( $(this).attr('type') + '_changed' ) } );
			$(parent).find('.simpleForm textarea').not('[readonly]').focus( function () { $(this).addClass( '_active' ) } );
			$(parent).find('.simpleForm textarea').not('[readonly]').blur( function () { $(this).removeClass( '_active' ) } );
			$(parent).find('.simpleForm textarea').not('[readonly]').change( function () { $(this).addClass( '_changed' ) } );
			$(parent).find('.simpleForm button').button();
		}
	};

	var main =
	{
		showHideDelay: 0
		,fixDRVPositioning: function ()
		{
			var driftRiskValueTop = $('#Head').outerHeight();
			var middleTop = $('#Head').outerHeight();
			if ( $('#DriftRiskValue').data('visible') )
				middleTop+= $('#DriftRiskValue').outerHeight();
			$('#Middle').css({ 'padding-top': middleTop });
			$('#DriftRiskValue').outerWidth( $('#Head').outerWidth() ).css({ 'position': 'fixed', 'z-index': '100', 'top': driftRiskValueTop });
			//$(window).scrollTop(0);
		}
		,block:
		{
			show: function ( block )
			{
 				if ( block == 'Home' )
				{
 					if ( !$('#Home').is(":visible") )
 					{
 						$('#DriftRiskValue, #navigation, .block').hide( main.showHideDelay ).data('visible',false);
 						$('#Home' ).delay( main.showHideDelay ).show( main.showHideDelay ).data('visible',true);
 					}
				}
 				else
					if ( !$('#block' + block ).is(":visible") )
					{
						$('.block').hide( main.showHideDelay ).data('visible',false);
						$('#DriftRiskValue, #navigation, #block' + block ).delay( main.showHideDelay ).show( main.showHideDelay ).data('visible',true);
						//main.block.setHeight( block );
						$('#navigation .section' + block + ' h2' ).addClass('active').closest('.section').siblings('.section').find('h2').removeClass('active');
					}
				main.fixDRVPositioning();
			}
			,setHeight: function ( block )
			{
				var temp = 0;
				$('#block' + block ).find('.question')
					.each( function () { temp = $(this).height() > temp ? $(this).height() : temp; } )
					.height( temp )
				;
			}
		}
		,answer:
		{
			check: function ( e, force )
			{
				if ( ( !force && $(this).hasClass('answer_checked') ) || force == 'uncheck' )
				{
					$(this).trigger('uncheck');
					if ( $(this).closest('.block').attr('block') == "SAS" )
						$(this).closest('.question').attr( 'factor', 0 );
					else
						$(this).closest('.question').attr( 'factor', 1 );
				}
				else
				{
					$(this).addClass('answer_checked').siblings('.answer').trigger('uncheck');
					$(this).closest('.question').attr( 'factor', $(this).attr('factor') );
				}
				var temp = 1;
				$(this).closest('.question').siblings('.question').andSelf().each( function () { temp = temp * $(this).attr('factor'); } );
				$(this).closest('.questions').attr('factor', temp );

				var situation = Math.round( $('#blockSAS .questions').attr('factor') * $('#blockMFC .questions').attr('factor') * 100 );
				var newSituation = Math.round( $('#blockSAS .questions').attr('factor') * $('#blockMFC .questions').attr('factor') * $('#blockDRM .questions').attr('factor') * 100 );

				main.setSituation( situation, newSituation );
				main.setRecommendation( situation, newSituation );
			}
			,uncheck: function ()
			{
				$(this).removeClass('answer_checked');
			}
		}
		,setSituation: function ( situation, newSituation )
		{
			var borderWidth = $('#graphSituation').outerWidth() - $('#graphSituation').width();
			
			$('#labelSituationValue span').text( situation );
			var barLength = $('#graphDRV').width() * ( situation < 200 ? situation : 200 ) / 200 - borderWidth;
			if ( barLength < 0 ) barLength = 0;
			$('#graphSituation').width( barLength );

			if ( $('#blockDRM .answer').filter('.answer_checked').length == 0 )
				$('.onlyMitigation:visible').hide();
			else
			{
				$('.onlyMitigation:hidden').show();
				main.setNewSituation( situation, newSituation, situation - newSituation );
			}
			main.fixDRVPositioning();
		}
		,setNewSituation: function ( situation, newSituation, mitigation )
		{
			// new situation bar length
			var borderWidth = $('#graphNewSituation').outerWidth() - $('#graphNewSituation').width();
			$('#labelNewSituationValue span').text( newSituation );
			var barLength = $('#graphDRV').width() * ( newSituation < 200 ? newSituation : 200 ) / 200 - borderWidth;
			if ( barLength < 0 ) barLength = 0;
			$('#graphNewSituation').width( barLength );

			/*** no mitigation bar
			// mitigation bar length
			var borderWidth = $('#graphMitigation').outerWidth() - $('#graphMitigation').width();
			$('#labelMitigationValue span').text( mitigation );

			var mitigationBarLength = mitigation;
			if ( mitigation > 0 )
			{
				if ( newSituation + mitigation >= 200 )
				{
					mitigationBarLength = 200 - newSituation;
					if ( mitigationBarLength < 0 )
						mitigationBarLength = 0;
				}
			}
			else if ( mitigation < 0 )
			{
				if ( situation >= 200 )
					mitigationBarLength = 0;
				else if ( newSituation >= 200 )
					mitigationBarLength = 200 - situation;
			}
			if ( mitigationBarLength < 0 )
				mitigationBarLength*= -1;
			mitigationBarLength = $('#graphDRV').width() * mitigationBarLength / 200 - borderWidth;
			$('#graphMitigation').width( mitigationBarLength );
			// bar position
			if ( mitigation <= 0 )
				$('#graphMitigation').addClass('graph_negative').css('margin-left', $('#graphNewSituation').outerWidth() - $('#graphMitigation').outerWidth() )
			else
				$('#graphMitigation').removeClass('graph_negative').css('margin-left', $('#graphNewSituation').outerWidth() )
			// label position
			var labelLength = $('#labelMitigation').outerWidth();
			var position = parseInt( $('#graphMitigation').css('margin-left') );
			if ( position + labelLength > $('#graphDRV').width() )
				position = $('#graphDRV').width() - labelLength;
			$('#labelMitigation').css( 'margin-left', position );
			*/
		}
		,setRecommendation: function ( situation, newSituation )
		{
			// SAS
			if ( $('#SASsensitiveArea .answer_checked').length == 0 )
				$('#blockSAS .recommend .comment').html( Labels.SAS.recommendation1 );
			else if ( $('#SASsensitiveArea .answer_checked').attr('factor') == 1 )
				$('#blockSAS .recommend .comment').html( Labels.SAS.recommendation2 );
			else
				$('#blockSAS .recommend .comment').html( Labels.SAS.recommendation3 );
			// MFC
			if ( situation < 50 )
				$('#blockMFC .recommend .comment').html( Labels.MFC.recommendation1 );
			else if ( situation < 100 )
				$('#blockMFC .recommend .comment').html( Labels.MFC.recommendation2 );
			else
				$('#blockMFC .recommend .comment').html( Labels.MFC.recommendation3 );
			// DRM
			if ( newSituation < 50 )
				$('#blockDRM .recommend .comment').html( Labels.DRM.recommendation1 );
			else if ( newSituation < 100 )
				$('#blockDRM .recommend .comment').html( Labels.DRM.recommendation2 );
			else
				$('#blockDRM .recommend .comment').html( Labels.DRM.recommendation3 );
		}
		,showDescription: function ()
		{
			$('#DescriptionDialog').html( $(this).data('description') ).dialog('open').find('a').attr( 'target', '_blank' );
		}
	}

	$(window).load( function ()
	{
		// show wait screen on ajax requests
		//$(document).ajaxSend ( function () { $("#Wait").fadeIn("fast"); });
	 	//$(document).ajaxStop ( function () { $("#Wait").fadeOut("fast"); } );

	 	$.ajaxSetup(
	 	{
	 		error: function ( jqXHR, textStatus, errorThrown ) { application.Error( '[' + jqXHR.status + '] ' + errorThrown ); }
		});

		/*
		 * Basic Error Dialog
		*/
		$("<div></div>", { id: "ErrorDialog" }).appendTo('#Dialogs').dialog({
			autoOpen: false
			,modal: true
			,resizable: false
			,width: 350
			,height: 200
			,buttons: [
				{
					text: Labels.error.button_ok
					,click: function() {
						$(this).dialog('close');
					}
				}
			]
		});
		/*
		 * Basic Message Dialog
		*/
		$("<div></div>", { id: "MessageDialog" }).appendTo('#Dialogs').dialog({
			autoOpen: false
			,modal: true
			,resizable: false
			,width: 350
			,height: 200
			,buttons: [
				{
					text: Labels.message.button_ok
					,click: function() {
						$(this).dialog('close');
					}
				}
			]
		});
		/*
		 * Basic Confirm Dialog
		*/
		$("<div></div>", { id: "ConfirmDialog" }).appendTo('#Dialogs').dialog({
			autoOpen: false
			,modal: true
			,resizable: false
			,width: 350
			,height: 200
			,buttons: [
				{
					text: Labels.confirm.button_yes
					,click: function()
					{
						// execute confirming
						application._confirmTodo();
						$(this).dialog('close');
						// reset confirming
						application._confirmTodo = function () {}
					}
				}
				,{
					text: Labels.confirm.button_no
					,click: function()
					{
						$(this).dialog('close');
						// reset confirming
						application._confirmTodo = function () {}
					}
				}
			]
		});
		/*
		 * Basic Login Dialog
		*/
		$("<div></div>", { id: "LoginDialog" }).appendTo('#Dialogs').dialog({
			autoOpen: false
			,modal: true
			,resizable: false
			,closeOnEscape: false
			,width: 450
			,height: 300
			,buttons: [
				{
					text: Labels.login.button_login
					,click: function() {
						application.doLogin( USER, PASSWORD );
					}
				}
			]
		});


		/*** Custom Stuff ***/
		
		$("<div></div>", { id: "DescriptionDialog" }).appendTo('#Dialogs').dialog({
			autoOpen: false
			,modal: true
			,resizable: false
			,width: $(window).width() * 0.95
			,height: $(window).height() * 0.95
			,show: 'blind'
			,hide: 'blind'
			,title: Labels.APPLICATION.dialogDescriptionTitle
			,buttons: [
				{
					text: Labels.APPLICATION.dialogCloseButton
					,click: function() {
						$(this).dialog('close');
					}
				}
			]
		});

		// fixing width
		$('#Head').outerWidth( $('#Head').outerWidth() ).css({ 'position': 'fixed', 'z-index': '100' });
		main.fixDRVPositioning();
		$(window).scroll( function () { $('#middleShadow').css({ 'display': $(window).scrollTop() > 1 ? 'block' : 'none' }) } );

		var temp = 0;
		$('.section h2')
			.each( function () { temp = $(this).children('div').height() > temp ? $(this).children('div').height() : temp; } )
			.each( function ()
			{
				var obj = $(this).children('div');
				obj.css( 'padding-top', ( ( temp - obj.height() + 10 ) / 2 ) + 'px' );
				obj.css( 'padding-bottom', ( ( temp - obj.height() + 10 ) / 2 ) + 'px' );
				
			})
			.click( function () { main.block.show( $(this).closest('.section').attr('block') ); } )
			.mouseover( function () { $(this).addClass('hover'); } )
			.mouseout( function () { $(this).removeClass('hover'); } )
		;
		$('.button[block]')
			.click( function ()
			{
				var block = $(this).attr('block');
				if ( block.indexOf('&') > 0 )
				{
					if ( block.substring( block.indexOf('&') + 1 ) == 'resetPage' )
						$(this).closest('.block').find('.answer').trigger('check','uncheck');
					else if ( block.substring( block.indexOf('&') + 1 ) == 'reset' )
						$('.answer').trigger('check','uncheck');
					block = block.substring( 0, block.indexOf('&') )
				}
				main.block.show( block );
			});
		var temp = 0;
		$('.section .inner')
			.each( function () { temp = $(this).height() > temp ? $(this).height() : temp; } )
			.height( temp )
		;
		$('.block').each( function ()
		{
			var itemsPerRow = $(this).find('.questions4col').length ? 4 : 3;
			for ( var i = 0; i < $(this).find('.question').length; i+= itemsPerRow )
			{
				var temp = 0;
				$(this).find('.question').slice( i, i + itemsPerRow )
					.each( function ()
					{
						temp = $(this).height() > temp ? $(this).height() : temp;
					})
					.height( temp )
				;
			}
		});
		$('.block, #navigation').not('#Home').hide();
		$('.onlyMitigation').hide();

		$('#Head')
			.click( function () { main.block.show( 'Home' ); } )
		;
		$('.questions, .question').attr( 'factor', 1 );
		$('#blockSAS .questions').attr( 'factor', 0 );
		$('.answer')
			.click( function () { $(this).trigger('check'); } )
			.mouseover( function () { $(this).addClass('answer_hover'); } )
			.mouseout( function () { $(this).removeClass('answer_hover'); } )
			.bind('check', main.answer.check)
			.bind('uncheck', main.answer.uncheck)
		;

		var height = $(window).height();
		height-= $('#Head').outerHeight();
		height-= $('#Foot').outerHeight();
		height-= $('#DriftRiskValue').outerHeight();
		//$('#scrollContainer').outerHeight( height );
		
		main.setRecommendation( 0, 0 );

		$('#DRMsdrtDriftReductionInput')
			.focus( function ()
			{
				var val = Math.round( parseInt( $(this).val() ) ? parseInt( $(this).val() ) : 0 );
				$(this).closest('.answer').attr( 'factor', ( 100 - val ) / 100 ).trigger( 'check', true ).siblings('.answer').trigger('uncheck');
			})
			.click( function ()
			{
				var val = Math.round( parseInt( $(this).val() ) ? parseInt( $(this).val() ) : 0 );
				$(this).closest('.answer').attr( 'factor', ( 100 - val ) / 100 ).trigger( 'check', true ).siblings('.answer').trigger('uncheck');
				return false;
			})
			.keyup( function ()
			{
				var val = Math.round( parseInt( $(this).val() ) ? parseInt( $(this).val() ) : 0 );
				$(this).closest('.answer').attr( 'factor', ( 100 - val ) / 100 ).trigger( 'check', true ).siblings('.answer').trigger('uncheck');
			})
			.closest('.answer').each( function()
			{
				var val = Math.round( parseInt( $('#DRMsdrtDriftReductionInput').val() ) ? parseInt( $('this#DRMsdrtDriftReductionInput').val() ) : 0 );
				$(this).attr( 'factor', ( 100 - val ) / 100 )
			})
		;
		
		// load xml labels
		$.ajax({
			type: 'GET'
			,url: 'init/Labels.' + GlobalConfig.APPLICATION.language + '.xml'
			,dataType: 'xml'
			,success: function ( xml )
			{
				$(xml).find('description').find('sectionDescription').children().each( function ()
				{
					var img = $('<img>', { src: "img/dialog-information-4.png" } ).click( main.showDescription ).data( 'description', $(this).text() );
					var obj = $( '<div class="icon"></div>' ).append( img );
					$( '.section' + $(this)[0].tagName + ' .inner' ).prepend( obj );
				});
				
				$(xml).find('description').find('drvDescription').children().each( function ()
				{
					var img = $('<img>', { src: "img/dialog-information-4.png" } ).click( main.showDescription ).data( 'description', $(this).text() );
					var obj = $( '<div class="icon"></div>' ).append( img );
					$( '#label' + $(this)[0].tagName + ' td' ).append( obj );
				});

				$(xml).find('description').find('questionDescription').children().each( function ()
				{
					$this = $(this);
					$(this).children().each( function () {
						var img = $('<img>', { src: "img/dialog-information-4.png" } ).click( main.showDescription ).data( 'description', $(this).text() );
						var obj = $( '<div class="icon"></div>' ).append( img );
						$( '#' + $this[0].tagName + $(this)[0].tagName + ' .title' ).prepend( obj );
					});
				});

				$(xml).find('description').find('specialDescription').children().each( function ()
				{
					var img = $('<img>', { src: "img/dialog-information-4.png" } ).click( main.showDescription ).data( 'description', $(this).text() );
					$( '.specialDescription' + $(this)[0].tagName + '' ).append( img );
				});
			}
		});

		$("#Wait").fadeOut("fast");
	});
	